/*-
 * Copyright (C)2005 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: mular_int.h,v 1.2 2005/05/10 13:46:13 babolo Exp $
 */

#ifdef INBUG
# define MULAR_INBUG(A, I) mular_place((A), (I) * INBUG)
#else
# define MULAR_INBUG(A, I)
#endif
#define ifMULAR_ZERO   if (mular->flags & MULAR_ZERO)

#define SIZE(A)        (mular->size[(A) - 1])                       /* size_t       */

#define NEXT(A)        ((A).link.next)                              /* mular_indir* */
#define LNEXT(I)       ((I) * sizeof(mular_indir))                  /* size_t       */
#define ND(N, I)       (&NEXT(dubl[N])[I])                          /* mular_indir* */
#define NCP(A, B, I)   {memmove((A), (B), LNEXT(I));}
#define NZR(A, I)      {bzero((A), LNEXT(I));}

#define TERM(A)        ((A).link.term)                              /* void*        */
#define LTERM(I)       ((I) * mular->unit)                          /* size_t       */
#define ATERM(A, I)    (TERM(A) + LTERM(I))                         /* void*        */
#define TD(N, I)       (ATERM((dubl[N]), (I)))                      /* void*        */
#define TCP(A, B, I)   {memmove((A), (B), LTERM(I));}
#define TZR(A, I)      {bzero((A), LTERM(I));}

#define ICONT(A, I)    ((A)->index - NEXT(*(A))[I].index)           /* ssize_t      */
#define ICONN(A, I, N) ((A)->index - ((N) = &NEXT(*(A))[I])->index) /* ssize_t      */
