/*-
 * Copyright (C)2005 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2005 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: test.c,v 1.3 2005/05/10 19:35:05 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include "../multilar.h"

int
main(int argc, char **argv) {
    int i, j;
    int level;
    u_int32_t flags, cflag = 0;
    mular_descriptor *mular;
    char **c;
    FILE *out = NULL;

    level = 0;
    flags = MULAR_CHAR | MULAR_HEXU | MULAR_DUAD | MULAR_SWP1 | MULAR_SWP2;
    if  (!argv) exit(EX_USAGE);
    while ((i = getopt(argc, argv, "fhl:qo:stuvz")) > 0) {
        switch (i) {
        case 'f':
            cflag++;
            break;
        case 'h':
            flags |= MULAR_HALF;
            break;
        case 'l':
            level = strtoul(optarg, NULL, 0);
            break;
        case 'q':
            flags &= ~BLIN_VERMASK;
            break;
        case 's':
            flags |= MULAR_STRI;
            break;
        case 'o':
            out = fopen(optarg, "a");
            break;
        case 't':
            flags &= ~(MULAR_HEXU | MULAR_DUAD);
            break;
        case 'u':
            flags |= MULAR_UPPE;
            break;
        case 'v':
            BLIN_VERBOSE(flags);
            break;
        case 'z':
            flags |= MULAR_ZERO;
            break;
        default:
            exit(EX_USAGE);
    }   }
    argc -= optind;
    argv += optind;
    if  (!out) out = stderr;
    if  (argc < level) exit(EX_USAGE);

    if  (!(mular = mular_create(flags, level, 0, NULL))) {
        fprintf(stderr, "mular_create not create\n");
        exit(1);
    }
    for (i = 0; i < level; i++) {
        mular->size[i] = strtoul(*argv, NULL, 0);
        argc--;
        argv++;
    }
    if  (!cflag) mular->flags &= ~(BLIN_VER3|BLIN_VER4|BLIN_VER5);
    for (i = 0; i < argc; i++) {
        ifBLIN_QV2(mular->flags) mular_dump(mular, out);
        for (j = 0; j < mular->top.index; j++) {
            c = (char**)mular_getix(mular, j);
            if  (!c || strcmp(argv[i], *c) <= 0) break;
        }
        if  (!cflag) mular->flags = flags;
        ifBLIN_QV1(mular->flags) fprintf(out, "###i=%d @@@%d=%s~\n", i, j, argv[i]);
        if  ((c = ((char**)mular_insert(mular, j)))) *c = argv[i];
          else fprintf(out, " \n");
        if  (!cflag) mular->flags &= ~(BLIN_VER3|BLIN_VER4|BLIN_VER5);
    }
    mular_dump(mular, out);
    for (i = 0; (c = ((char**)mular_getix(mular, i))); i++) {
        fprintf(out, "%d=", i);
        fprintf(out, "%s~\n", *c);
    }
    mular_destroy(mular);
    exit(EX_OK);
}
